import ch.usi.dag.disl.snippet.Shadow;
import ch.usi.dag.disl.staticcontext.AbstractStaticContext;
import ch.usi.dag.disl.util.cfg.BasicBlock;
import ch.usi.dag.disl.util.cfg.CtrlFlowGraph;

public class MyLoopContext extends AbstractStaticContext {
	
	private CtrlFlowGraph cfg;

	public void staticContextData(Shadow sa) {

		super.staticContextData(sa);

		// build control flow graph for this method
		cfg = CtrlFlowGraph.build(staticContextData.getMethodNode());
	}

	public boolean methodContainsLoop() {

		// test all basic blocks
		for (BasicBlock bb : cfg.getNodes()) {

			// test all basic block successors
			for (BasicBlock successor : bb.getSuccessors()) {

				// successor has lower index => loop detected
				if (bb.getIndex() >= successor.getIndex()) {
					return true;
				}
			}
		}

		// no loop detected
		return false;
	}

}
