# /bin/sh

########################################################
#	Compiling DiSL
########################################################

# test number of arguments
EXPECTED_ARGS=1
if [ $# -lt $EXPECTED_ARGS ]
then
    echo "Usage: `basename $0` example-name"
    exit
fi

CURRENT=`pwd`

# default DiSL lib path
if [ -z "${DISL_HOME}" ]; then
    DISL_HOME=${CURRENT}/..
fi

cd ${DISL_HOME}
echo "Compiling DiSL..."
ant > /dev/null
cd ${CURRENT}

########################################################
#	Running Example
########################################################

if [ -d ${1} ]
then
    echo "Running example ${1}..."
    EXAMPLE=${CURRENT}/${1}
    cd ${EXAMPLE}/app
    ant > /dev/null
    cd ${EXAMPLE}/instr
    ant > /dev/null
    cd ${EXAMPLE}
    ./runApp.sh instr/build/disl-instr.jar -jar app/build/example-app.jar
else
    echo "Example ${1} not exists"
fi

